<template>
    <v-container class="main-container" fluid pa-0>
        <div class="form-container" fluid>
            <v-row>
                <v-col>
                    <v-form class="form">
                        <v-text-field v-model="nameSearch" label="Filter By Name"></v-text-field>
                        <v-text-field v-model="idSearch" label="Filter By Id"></v-text-field>
                    </v-form>
                </v-col>
                <v-col>
                    <div class="control-right">
                        <v-switch v-model="toggleCardDisplay" label="Card Display">OK</v-switch>
                        <v-select v-model="toggleOrderSelection" :items="orderItems" label="Order List" item-text="name" item-value="id"></v-select>
                    </div>
                </v-col>
                <v-col>
                    <v-slider label="Number of displayed heroes" min="1" max="100" thumb-label class="slider" v-model="maxHeroesDisplayed"></v-slider>
                </v-col>
            </v-row>
        </div>
        <div  fluid v-if="toggleCardDisplay" class="heroes-container fill-height">
            <v-card  class="heroes-card" v-for="hero in DisplayList" :key="hero.name" v-on:click="dialog = true; currentHero = hero;">
                <v-row>
                    <v-img class="image" :src=hero.path></v-img>
                </v-row>
                <v-row justify="center" align="center">
                    <v-card-title>{{hero.name}} - {{hero.id}}</v-card-title>
                    <v-btn icon @click.native.stop v-on:click="ToggleFav(hero)">
                        <span v-if="!hero.isFav" key="not-clicked"><i  class="far fa-heart" ></i></span>
                        <span v-else key="clicked"><i  class="fa fa-heart"></i></span>
                    </v-btn>
                </v-row>
            </v-card>
            <v-dialog v-model="dialog" max-width="50%">
                <v-card class="modal-hero">
                    <v-img class="image-modal" :src=currentHero.path></v-img>
                    <v-card class="info-modal">
                        <v-card-title>{{currentHero.name}}</v-card-title>
                        <h2 v-if="!editEnable">{{currentHero.description}}</h2>
                        <Editable v-if="editEnable" :editText="currentHero.description" v-on:close-event="editEnable=false" :hero="currentHero"></Editable>
                        <div class="button-container" v-if="!editEnable">
                            <v-btn v-on:click="EditHero(currentHero)" >Edit</v-btn>
                            <v-btn v-on:click="ToggleFav(currentHero)">Like</v-btn>
                            <v-btn v-on:click="dialogDelete = true">Delete</v-btn>
                        </div>
                    </v-card>
                </v-card>
            </v-dialog>
        </div>

        <div v-if="!toggleCardDisplay" class="heroes-container">
            <v-expansion-panels>
                <v-expansion-panel v-for="hero in DisplayList" :key="hero.name" class="fav-card">
                    <v-expansion-panel-header>
                        <v-row justify="center" align="center" class="spacer" no-gutters>
                            <v-col>
                                <v-avatar size="200" tile class="avatar">
                                    <v-img :src="hero.path"></v-img>
                                </v-avatar>
                            </v-col>
                            <v-col>
                                <h2 class="name">
                                    {{hero.name}}
                                </h2>
                            </v-col>
                            <v-col>
                                <h2>{{hero.id  }}</h2>
                            </v-col>
                            <v-col>
                                <v-btn icon @click.native.stop v-on:click="ToggleFav(hero)">
                                    <span v-if="!hero.isFav" key="not-clicked"><i  class="far fa-heart" ></i></span>
                                    <span v-else key="clicked"><i  class="fa fa-heart"></i></span>
                                </v-btn>
                            </v-col>
                            <v-col>
                                <v-btn icon @click.native.stop v-on:click="EditHero(hero)">
                                    <span><i  class="far fa-edit" ></i></span>
                                </v-btn>
                            </v-col>
                            <v-col>
                                <v-btn icon @click.native.stop v-on:click="dialogDelete=true; currentHero = hero">
                                    <span ><i  class="fa fa-times" ></i></span>
                                </v-btn>
                            </v-col>
                        </v-row>
                    </v-expansion-panel-header>
                    <v-expansion-panel-content>
                        <v-row>
                            <v-col>
                                <Editable v-if="editEnable" :editText="currentHero.description" v-on:close-event="editEnable=false" :hero="currentHero" v-on:click="currentHero = hero"></Editable>
                                <h2 v-else>{{hero.description}}</h2>
                            </v-col>
                        </v-row>
                    </v-expansion-panel-content>
                </v-expansion-panel>
            </v-expansion-panels>
        </div>

        <v-dialog v-model="dialogDelete" max-width="50%">
            <v-card class="dialog-delete">
                <v-card-title  style="font-size: large" class="justify-center">Delete Heroes</v-card-title>
                <h1 style="text-align: center">Are you sure?</h1>
                <div class="button-center">
                    <v-btn v-on:click="DeleteHeroFromStore(currentHero)">YES</v-btn>
                </div>
            </v-card>
        </v-dialog>

        <div class="pagination-container">
            <v-pagination v-model="page" :length="PaginationLength" total-visible="8"></v-pagination>
            <v-btn
                    class="loadmore-button"
                   v-on:click="LoadMore"
                    :loading="loading"
            >
                Load More
            </v-btn>
        </div>
    </v-container>
</template>

<script>
    import {mapActions, mapState} from 'vuex';
    import Editable from "./Editable";
    import axios from "axios";
    import {public_key} from "../Marvel";

    export default {
        name: "Heroes",

        data: function() {
            return {
                marvelLogo:  require('../assets/Marvel-Comics-Logo.png'),
                dialog: false,
                currentHero: {},
                editEnable: false,
                clicked: false,
                nameSearch: null,
                idSearch: null,
                page: 1,
                loading: false,
                dialogDelete: false,
                orderItems: [
                    {
                        id: 0,
                        name:"Alphabetically"
                    },
                    {
                        id: 1,
                        name:"By Id"
                    },
                    {
                        id: 2,
                        name:"No Order"
                    }
                ],
            };
        },

        mounted() {
        },
        computed:{
            ...mapState({
                heroesList: state => state.heroes
            }),
            FilterByName: function(){
                return this.$store.getters.nameFilter(this.nameSearch, this.idSearch)
            },
            DisplayList: function () {
                if (this.page * this.maxHeroesDisplayed <= this.FilterByName.length){
                    return this.SortList.slice((this.page - 1) * this.maxHeroesDisplayed, this.page * this.maxHeroesDisplayed)
                }
                else{
                    return this.SortList.slice((this.page - 1) * this.maxHeroesDisplayed, this.FilterByName.length)
                }
            },
            PaginationLength: function () {
                return Math.floor((this.FilterByName.length + this.maxHeroesDisplayed) / this.maxHeroesDisplayed)
            },
            SortList: function(){
                let arrayCopy = this.FilterByName.slice()
                if (this.toggleOrderSelection == 0){
                    return arrayCopy.sort( (a,b) => {
                        return a.name.toLowerCase().localeCompare(b.name.toLowerCase())
                    })
                }
                else if (this.toggleOrderSelection == 1){
                    return arrayCopy.sort( (a,b) => {
                        return parseInt(a.id) > parseInt(b.id)
                    })
                }
                else{
                    return arrayCopy
                }
            },
            maxHeroesDisplayed: {
              get(){
                  return this.$store.state.maxHeroesDisplayed
              },
              set(value){
                  this.$store.commit('SET_MAX_HEROES_DISPLAYED', value)
              }
            },
            toggleCardDisplay: {
                get(){
                    return this.$store.state.displayCard
                },
                set(value) {
                    this.$store.commit('TOGGLE_DISPLAY_CARD', value)
                }
            },
            toggleOrderSelection: {
                get(){
                    return this.$store.state.orderSelection
                },
                set(value) {
                    this.$store.commit('TOGGLE_ORDER_SELECTION', value)
                }
            }
        },

        methods:{
            ...mapActions([
                "DeleteHero",
                "GetHeroes"
            ]),
            ToggleFav: function(hero){
                if (hero.isFav !== true){
                    this.$store.dispatch("AddFavHero", hero)
                }
                else{
                    this.$store.dispatch('DeleteFavHero', hero)
                }
            },
            EditHero: function(hero){
                console.log("okok")
                console.log(hero)
                this.$router.push({name:"EDIT", params: {hero: hero}})
            },
            LoadMore: function(){
                this.loading = true
                const offset = this.$store.getters.nbrOfHeroes
                this.GetHeroes(offset)
                .then(()=>{
                    this.loading = false
                })
            },
            DeleteHeroFromStore: function(p_hero){
                this.DeleteHero(p_hero)
                this.dialogDelete = false
                this.dialog = false
            }
        },
        components:{
            Editable
        }
    }
</script>

<style scoped>
    .image{
        height: 40%;
        width: auto;
    }
    .heroes-container{
        width: 100%;
        background-color: #2c3e50;
        display: flex;
        max-height: 100%;
        align-content: space-between;
        flex-wrap: wrap;
        justify-content: center;
        overflow: auto;
        margin-top: 2%;
    }
    .heroes-card{
        background-color: aliceblue;
        width: 15%;
        margin: 5%;
        /*height: 30%;*/
        overflow: hidden;
    }
    .modal-hero{
        display: flex;
    }
    .image-modal{
        flex: 2
    }
    .info-modal{
        flex:3
    }
    .form-container{
        padding: 0 5% 0 5%;
        background-color: white;
    }
    .main-container{
        background-color: #2c3e50;
        height: 100%;
        display: flex;
        flex-direction: column;
    }
    .control-right{
        padding-left: 10%;
    }
    html, body{
        height: 100%;
    }
    .pagination-container{
        padding: 5% 0 2% 0;
        display: flex;
        justify-content: center;
    }
    .loadmore-button{
        margin-left: 100px;
    }
    .slider{
        margin-top: 5%;
    }
    .button-container{
        display: flex;
        justify-content: space-between;
        padding: 5% 5% 0 5%;
    }
    .button-center{
        display: flex;
        justify-content: center;
        padding-top: 5%;
    }

</style>